/**
 * Trieda apletu pre vytvorenie a inicializaciu apletu
 * @author = Ivana Hvizdosova
 * @version = 1.0
 */
import java.awt.BorderLayout;
import java.awt.Event;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JPanel;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JEditorPane;
import javax.swing.JTextField;



public class BBA extends JApplet {

	private JPanel jContentPane = null;
	private JPanel pnl_west = null;
	
	private JButton btn_st_sp = null;
	private JButton btn_step = null;
	private JButton btn_faster = null;
	private JButton btn_slower = null;
	private JButton btn_reset = null;
	private JButton btn_clear = null;
	
	private JComboBox chc_automat = null;
	private JComboBox chc_demo = null;
		
	private JCheckBox chb_loop = null;
	private JCheckBox chb_signalX = null;
	private JCheckBox chb_signalY = null;
		
	private JLabel jLabel = null;
	private JLabel lbl_demo = null;
	private JLabel jLabel1 = null;
	
//	private JTextField jTextField = null;

	//	automaty
	//BBA.java ako hl.program deklaruje referencie na ostatne triedy, pomocou ktorych vola ich metody(stali sa dat.prvkami triedy BBA)
	private MargPanel margolus;      //panel vlastnej implementacie margolusa
    private State16Panel state16;	 //panel implementacie 16stavoveho RCA
    private AutomatPanel Automat;	 //premenna do ktrorej sa nastavi aktualny typ automatu
	

	/**
	 * This is the default constructor
	 */
	public BBA() {
		super();   //v konzstruktore BBA volanie konstruktora rodicovskej triedy
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	public void init() {
		this.setSize(533,555);
		this.setContentPane(getJContentPane());
		InitAutomats();
	
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.RAISED));
			jContentPane.setPreferredSize(new java.awt.Dimension(1,1));
			jContentPane.add(getPnl_west(), null);

		}
		return jContentPane;
	}


	
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtn_st_sp() {
		if (btn_st_sp == null) {
			btn_st_sp = new JButton();
			btn_st_sp.setText("start");
			btn_st_sp.setBounds(new java.awt.Rectangle(7,82,77,25));
			btn_st_sp.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					action(e);
				}
			});
		}
		return btn_st_sp;
	}


	/**
	 * This method initializes jButton6	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtn_step() {
		if (btn_step == null) {
			btn_step = new JButton();
			btn_step.setText("krok");
			btn_step.setBounds(new java.awt.Rectangle(91,82,77,25));
			btn_step.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					action(e);
				}
			});
		}
		return btn_step;
	}

	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtn_faster() {
		if (btn_faster == null) {
			btn_faster = new JButton();
			btn_faster.setText("zrychli");
			btn_faster.setSize(new java.awt.Dimension(77,26));
			btn_faster.setLocation(new java.awt.Point(175,82));
			btn_faster.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					action(e);
				}
			});
		}
		return btn_faster;
	}

	/**
	 * This method initializes jButton2	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtn_slower() {
		if (btn_slower == null) {
			btn_slower = new JButton();
			btn_slower.setText("spomal");
			btn_slower.setBounds(new java.awt.Rectangle(259,82,77,26));
			btn_slower.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					action(e);
				}
			});
		}
		return btn_slower;
	}

	/**
	 * This method initializes jButton3	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtn_reset() {
		if (btn_reset == null) {
			btn_reset = new JButton();
			btn_reset.setText("reset");
			btn_reset.setBounds(new java.awt.Rectangle(427,82,77,26));
			btn_reset.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					action(e);
				}
			});
		}
		return btn_reset;
	}

	/**
	 * This method initializes jButton4	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtn_clear() {
		if (btn_clear == null) {
			btn_clear = new JButton();
			btn_clear.setText("clear");
			btn_clear.setBounds(new java.awt.Rectangle(343,82,77,26));
			btn_clear.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					action(e);
				}
			});
		}
		return btn_clear;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPnl_west() {
		if (pnl_west == null) {
			lbl_demo = new JLabel();
			lbl_demo.setBounds(new java.awt.Rectangle(19,52,64,16));
			lbl_demo.setText("Zvol demo  ");
			jLabel = new JLabel();
			jLabel.setText("Zvol CA   ");
			jLabel.setBounds(new java.awt.Rectangle(31,19,51,16));
			jLabel1 = new JLabel();
			jLabel1.setBounds(new java.awt.Rectangle(279,48,50,16));
			jLabel1.setText("Krok 0");
			pnl_west = new JPanel();
			pnl_west.setLayout(null);
			pnl_west.setBounds(new java.awt.Rectangle(8,430,517,121));
			pnl_west.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
			pnl_west.add(jLabel, null);
			pnl_west.add(jLabel1, null);
			pnl_west.add(getChc_automat(), null);
			pnl_west.add(getBtn_step(), null);
			pnl_west.add(getBtn_reset(), null);
			pnl_west.add(getBtn_faster(), null);
			pnl_west.add(getBtn_clear(), null);
			pnl_west.add(getBtn_slower(), null);
			pnl_west.add(getBtn_st_sp(), null);
			pnl_west.add(getChc_demo(), null);
			pnl_west.add(lbl_demo, null);
			pnl_west.add(getChb_loop(), null);
			pnl_west.add(getChb_signalX(), null);
			pnl_west.add(getChb_signalY(), null);
//			pnl_west.add(getJTextField(), null);
		}
		return pnl_west;
	}

	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getChc_automat() {
		if (chc_automat == null) {
			chc_automat = new JComboBox();
			chc_automat.setEditable(false);
			chc_automat.setPreferredSize(new java.awt.Dimension(115,25));
			chc_automat.setBackground(new java.awt.Color(250,250,250));
			chc_automat.setBounds(new java.awt.Rectangle(85,13,153,25));
			chc_automat.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(Automat!=null)
						action(e);
				}
			});
		}
		return chc_automat;
	}

	/**
	 * This method initializes jComboBox1	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getChc_demo() {
		if (chc_demo == null) {
			chc_demo = new JComboBox();
			chc_demo.setEditable(false);
			chc_demo.setBounds(new java.awt.Rectangle(85,46,152,25));
			chc_demo.setBackground(new java.awt.Color(250,250,250));
			chc_demo.setPreferredSize(new java.awt.Dimension(115,25));
			chc_demo.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(Automat!=null)
						action(e);
				}
			});
		}
		return chc_demo;
	}


	/**
	 * This method initializes jCheckBox1	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getChb_loop() {
		if (chb_loop == null) {
			chb_loop = new JCheckBox();
			chb_loop.setBounds(new java.awt.Rectangle(279,14,64,21));
			chb_loop.setText("Loop");
			chb_loop.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					action(e);
				}
			});
		}
		return chb_loop;
	}
	
	/**
	 * This method initializes jCheckBox2	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getChb_signalX() {
		if (chb_signalX == null) {
			chb_signalX = new JCheckBox();
			chb_signalX.setBounds(new java.awt.Rectangle(386,14,82,21));
			chb_signalX.setText("signal X");
			chb_signalX.setEnabled(false);
			chb_signalX.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					action(e);
				}
			});
			
		}
		return chb_signalX;
	}

	/**
	 * This method initializes jCheckBox3	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getChb_signalY() {
		if (chb_signalY == null) {
			chb_signalY = new JCheckBox();
			chb_signalY.setBounds(new java.awt.Rectangle(386,46,83,21));
			chb_signalY.setText("signal Y");
			chb_signalY.setEnabled(false);
			chb_signalY.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					action(e);
				}
			});
		}
		return chb_signalY;
	}


	/**
	 * funkcia stop
	 * zastavi chod automatu
	 */
	public void bba_stop()
	{      
		Automat.stop();					//vlastne zastavenie automatu
		btn_st_sp.setText("Start");	//menime napis
		btn_step.setEnabled(true);				//povolime step
		btn_clear.setEnabled(true);				//povolime clear
	}
	
	/**
	 * funkcia start
	 * spusti chod automatu
	 */
	public void bba_start()
	{ 
		btn_st_sp.setText("STOP");		//menime napis
		btn_step.setEnabled(false);		//zakazeme step
		btn_clear.setEnabled(false);	//zakazeme clear
		Automat.start();   //odstartujeme automat, co je v konecnom dosedku implementovana metoda step()

	}
	
/**
 * je volana v samotnych automatoch vo funkcii step()
 * @param krok je pocet opakovani volania funkcie step() pre jeden loop
 */
	
	public void krokuj(int krok){
		jLabel1.setText("Krok " + krok);
	}
	
//	funkcia inicializuje automat (panel automatu)
	private void InitAutomats()
	{
		//registrujeme podporovane automaty
		chc_automat.addItem("Margolusov BBA");
		chc_automat.addItem("16 stavovy CA");
		
		chc_demo.addItem("Pohyb gule");
		chc_demo.addItem("Vlastne demo");
		chc_demo.addItem("Stabilny prvok");
		chc_demo.addItem("Odraz od zrkadla");
		chc_demo.addItem("Posun A");
		chc_demo.addItem("Posun B");
		chc_demo.addItem("I-brana (zrazka 2 guli)");
		chc_demo.addItem("S-hradlo");
		chc_demo.addItem("Netrivialne krizenie");
		chc_demo.addItem("Oneskorenie");
		
		//vytvorime podporovane automaty
		margolus = new MargPanel(this);
		state16 = new State16Panel(this);
	
		margolus.setBounds(54,10,419,415);
		//registrujeme pre aplet defaultny automat
		jContentPane.add(margolus,BorderLayout.CENTER);
		
		//nastavime parametre podla defaultneho automatu
		margolus.setX(true);
		margolus.setY(true);
		chb_loop.setSelected(margolus.autorestart);
		chb_signalX.setSelected(margolus.signalX);
		chb_signalY.setSelected(margolus.signalY);
		//nastavime premennu Automat na defaultny
		Automat=margolus;
	}
 
	private void SetAutomat(int typ)
	{
		 bba_stop();	//zastavime automat
	 	 
		switch(typ)		//podla typu prepneme
		{
		case 0:			//margolusov
			//vymena automatu
			jContentPane.remove(state16);					//odregistrujeme
			margolus.setBounds(54,10,419,415);   // !! rozmer mriezky !!!
			jContentPane.add(margolus,null); //zaregistrujeme novy
			Automat=margolus;
			break;
		case 1:			//16 stavovy RCA
			//vymena automatu
			jContentPane.remove(margolus);
			state16.setBounds(54,10,419,415);
			jContentPane.add(state16,null);
			Automat=state16;
			break;
		default:break;
		}
		//nastavime rezimy
		System.out.println(chc_demo.getComponentCount());   //??
		
		chb_loop.setSelected(Automat.autorestart);
		Automat.setX(Automat.signalX);
		Automat.setY(Automat.signalY);
		chb_signalX.setSelected(Automat.signalX);
		chb_signalY.setSelected(Automat.signalY);
		//reinicializujeme layout - musi byt volane explicitne !!!
		jContentPane.doLayout();
		Automat.repaint();
	}
 
	/**
	 * realizuje zmenu oznacenie Signal X/Y na X/C
	 *
	 */
	private void zmenaXY_XC(){
		if((chc_demo.getSelectedIndex())==7){
			switch((chc_automat.getSelectedIndex())){
			case 0:
				chb_signalY.setText("Signal C");
				chb_signalX.setText("Signal X");
				break;
			case 1:
				chb_signalY.setText("Signal X");
				chb_signalX.setText("Signal C");
				break;
			default:
				break;
			}
		}
		else {
			chb_signalX.setText("Signal X");
			chb_signalY.setText("Signal Y");
		}
		
	}
	
 	/**
	 * dekodovacia mapa sprav
	 * realizuje vyvolavanie metod asociovanych s jednotlivymi objektami
	 */
	public boolean action(ActionEvent e)
	{
		if (e.getSource() == chc_automat)	//vyber automatu
		{
			SetAutomat(chc_automat.getSelectedIndex());
			Automat.SetDemo(chc_demo.getSelectedIndex());
			zmenaXY_XC();
		}
	    else if (e.getSource() == btn_st_sp)	//stlacenie start/stop
	    {   if (Automat.timer != null)
				bba_stop();
			else
				{
				bba_start();
				
				}
		}
	    else if (e.getSource() == btn_step)	//stlacenie step
	    {
			Automat.step();
		}
		else if (e.getSource() == btn_reset)	//stlacenie reset
		{
			Automat.reset();
	       
		}
		else if (e.getSource() == btn_clear)	//stlacenie clear
	    {
			Automat.clear();
		}
		else if (e.getSource() == btn_slower)//stlacenie slower
		{
			Automat.runslower();
	    }
	    else if (e.getSource() == btn_faster)//stlacenie faster
	    {
			Automat.runfaster();
		}
		else if (e.getSource() == chc_demo)	//vyber dema
		{
			Automat.SetDemo(chc_demo.getSelectedIndex());
			if ((chc_automat.getSelectedIndex())==0 && ((chc_demo.getSelectedIndex())==6 || (chc_demo.getSelectedIndex())==7 || (chc_demo.getSelectedIndex())==8)) {
				chb_signalX.setEnabled(true);
				chb_signalY.setEnabled(true);
				}
			if ((chc_automat.getSelectedIndex())==1 && ((chc_demo.getSelectedIndex())==8 || (chc_demo.getSelectedIndex())==0  || (chc_demo.getSelectedIndex())==6 || (chc_demo.getSelectedIndex())==7)) {
				chb_signalX.setEnabled(true);
				chb_signalY.setEnabled(true);
				}
			if ((chc_automat.getSelectedIndex())==0 && ((chc_demo.getSelectedIndex())==0 || (chc_demo.getSelectedIndex())==1 || (chc_demo.getSelectedIndex())==2 || (chc_demo.getSelectedIndex())==3 || (chc_demo.getSelectedIndex())==4 || (chc_demo.getSelectedIndex())==5 || (chc_demo.getSelectedIndex()==9))) {
				chb_signalX.setEnabled(false);
				chb_signalY.setEnabled(false);
				}
			if ((chc_automat.getSelectedIndex())==1 && ((chc_demo.getSelectedIndex())==1 || (chc_demo.getSelectedIndex())==2 || (chc_demo.getSelectedIndex())==4 || (chc_demo.getSelectedIndex())==5  || (chc_demo.getSelectedIndex())==9 || (chc_demo.getSelectedIndex())==0 || (chc_demo.getSelectedIndex())==3)) {
				chb_signalX.setEnabled(false);
				chb_signalY.setEnabled(false);
				}
			chb_signalY.setSelected(true);
			chb_signalX.setSelected(true);
			
			Automat.setX(true);
			Automat.setY(true);
			Automat.SetDemo(chc_demo.getSelectedIndex());
			zmenaXY_XC();           //zmena signlal X/Y na X/C
		}
		else if (e.getSource() == chb_loop)	//zaskrtnutie loopu
		{
			Automat.autorestart=chb_loop.isSelected();
		}
		else if (e.getSource() == chb_signalX)	//zaskrtnutie signal X
		{
			Automat.setX(chb_signalX.isSelected());
			Automat.SetDemo(chc_demo.getSelectedIndex());
		}
		else if (e.getSource() == chb_signalY)	//zaskrtnutie signal Y
		{
			Automat.setY(chb_signalY.isSelected());
			Automat.SetDemo(chc_demo.getSelectedIndex());
		}
				
		return true;
	}
 
	/**
	 * destruktor apletu
	 * zastavi beziaci automat (pre kazdy pripad - automat bezi v novom threade)
	 */
	public void destroy()
	{
	  Automat.stop(); //automat zastavime
	}
	
}
