import java.awt.*;
import java.util.ArrayList;
//import java.awt.event.*; 
//import java.awt.image.*;
//import java.lang.Math.*;

import javax.swing.JComboBox;

/**
 * Implementacia 16 stavoveho RCA automatu
 * Trieda vyuzivana triedu State16Cell na reprezentaciu bunky automatu
 * @author = Ivan Klimko
 * @version = 2.0
 */
public class State16Panel extends AutomatPanel
{
	private BBA user_intf;						//referencia na panel volieb
	
	private int sizX;							//velkost mriezky X
	private int sizY;							//                Y
	private State16Cell[][] Data; //Data
	private State16Cell[][] Data3;
	private int gulaX=1;
	private int gulaY=1;
//	private State16Cell[][] Data2;
						
	private boolean zmena;						//pomocna premenna pre autostop
	
	//volby pre demo a mod ohranicenia
	private int demo = 0;
	private boolean isWrap = false;				//nie je sfericky - default nesfericky,s odrazom
	
	//pravidla
						//  0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15
	private int[] rule1 = { 0, 4, 8, 3, 1,10, 6, 7, 2, 9, 5,11,12,13,14,15 };
	private int[] rule2 = { 0, 4, 8, 3, 1,10, 6,11, 2, 9, 5,13,12,14, 7,15 };
	private int[] swapArray = rule1;		  

	//buffer pre kreslenie
	private Image imbuffer;						
	
	/**
	 * vytvorenie dvojdimenzionalneho pola cell
	 */
	private State16Cell[][] make2Dcell(int x ,int y)
	{	
		State16Cell[][] pole = new State16Cell[x][y];
		for(int i=0;i<x;i++)
			for(int j=0;j<y;j++)
				pole[i][j]=new State16Cell();
		return pole;
	}

	/**
	 * Konstruktor
	 * @param BBA ui referencia na triedu obsahujucu panel volieb
	 */
	public State16Panel(BBA ui)
	{
		this.user_intf=ui;
		Data3=make2Dcell(sizX,sizY);
	}

	/**
	 * implement8cia funkcie pre priznak gule X / JCheckBox signalX
	 * @param chb_signalX b
	 */	
	public void setX(boolean b) {
		if (b==false)
			gulaX=0;
		else gulaX=1;
		SetDemo(demo);
	}
	
	/**
	 * impelmentacia funkcie pre priznak gule Y / JCheckBox signalY
	 * @param chb_signalY b
	 */
	public void setY(boolean b) {
		if (b==false)
			gulaY=0;
		else gulaY=1;
		SetDemo(demo);
	}
	
	
		
	/**
	 * funkcia pre ulozenie vsetkych nvaolenych gul uzivatelom 
	 */
	public void saveData(){
		for(int i=0;i<sizX;i++)
			for(int j=0;j<sizY;j++)
		       Data3[i][j]=Data[i][j];
		
	}
	
	/**
	 * implementacia ...
	 */
	public void InitSetDemo(){
		   sizX=16;
		   sizY=16;
		   SetSize();
		   placeBall( 0, 6,'e', gulaX);
		   placeBall(13,15,'n', gulaY);
		   kresli();
//		   
	}
	/**
	 * 	implementacia funkcie pre nastavenie dema
	 * @param int demo - poradove cislo dema
	 */
	public void SetDemo(int demo)
	{
		this.demo = demo;
		krok=0;
		switch(demo)
		{
		case 0:  //pohyb gule
			   sizX=16;
			   sizY=16;
			   SetSize();
			   placeBall( 0, 6,'e', gulaX);
			   break;
		case 1:  //vlastne demo
			   sizX=16;
			   sizY=16;
			   SetSize();
			   
			   for(int i=0;i<sizX;i++)
					for(int j=0;j<sizY;j++)
						Data[i][j]=Data3[i][j];
			   break;
		case 2:  //stabilny prvok
			   sizX=16;
			   sizY=16;
			   SetSize();
			   placeBox( 7, 7);
			   break;
   		case 3: //odraz od zrkadla
			   sizX=16;
			   sizY=16;
			   SetSize();
			   //zrkadlo
			   placeBox( 6, 5);
			   placeBox( 7, 6);
			   placeBox( 8, 7);
			   placeBox( 9, 8);
			   	   
			   placeBall(13, 5,'w', gulaX);	//gula1
			   placeBall( 0, 9,'e', gulaY);	//gula2
			   break;
   		case 4:  //posun o 2
			sizX=16;
			sizY=16;
		   SetSize();
		   placeBall( 0, 8,'e', gulaX);	//gula 
		   placeBox(6,6);
		   placeBox(7,7);
		   placeBox(4,10);
		   placeBox(5,11);
		   break;
		case 5:  //posun o 3
			sizX=16;
			sizY=16;
		   SetSize();
		   placeBall( 0, 8,'e', gulaX);	//gula 
		   placeBox(6,6);
		   placeBox(7,7);
		   placeBox(4,11);
		   placeBox(5,12);
		   break;
		case 6:sizX=16; //I-brana
			   sizY=16;
			   SetSize();
			   placeBall( 0, 7,'e', gulaX);	//gula 1
			   placeBall( 8,15,'n', gulaY);	//gula 2
			   break;
		case 7:sizX=16;   //S-brana
			   sizY=17;
			   SetSize();
			   placeBox( 4, 1);
			   placeBox( 3, 2);
			   placeBox( 8, 0);
			   placeBox( 7, 1);
			   placeBox(10, 3);
			   placeBox( 9, 4);
			   placeBox( 8, 5);
			   placeBox( 7, 6);
			   placeBox(14, 7);
			   placeBox(13, 8);
			   placeBox(14, 9);
			   placeBox(14,11);
			   placeBox(13,12);
			   placeBox(11,12);
			   placeBox( 9,12);
			   placeBox(10,11);
			   
			   placeBall( 0,10,'e', gulaX);
			   placeBall( 6,16,'n', gulaY);
			   break;
		case 8://nontrivial crossover
			   sizX=16;
			   sizY=16;
			   SetSize();
			   placeBox(5,5);
			   placeBox(4,6);
			   placeBox(9,9);
			   placeBox(8,10);
			   placeBall(0,8,'e', gulaX);
			   placeBall(7,15,'n', gulaY);
			   break;
		
		case 9:  // oneskorenie
			sizX=16;
			sizY=16;
		   SetSize();
		   placeBall( 0, 8,'e', gulaX);	//gula 
		   placeBox(7,5);
		   placeBox(6,6);
		   placeBox(7,7);
		   placeBox(8,6);
		   placeBox(4,10);
		   placeBox(5,11);
		   placeBox(10,10);
		   placeBox(9,11);
		   break;
		
		default: 
			   break;
		}
		user_intf.krokuj(0);
		kresli();
	}
	
// funkcie pre mod cinnosti
	/**
     * implementacia funkcie pre ziskanie informacii o podporovanych rezimoch cinnosti
     * @param Choice volba - referencia na objekt rozhrania triedy java.awt.Choice
	 */
	public void GetModes(JComboBox volba)
	{
		volba.removeAllItems();
		volba.addItem("Bez odrazu");
		volba.addItem("Sfericky povrch");
	}
	/**
	 * funkcia pre nastavenie rezimu cinnosti
	 * @param int mode - poradove cislo modu
	 */
	public void SetMode(int mode)
	{
		switch(mode)
		{
		case 0:
				isWrap=false;
				break;
		case 1:
				isWrap=true;
				break;
		default:break;
		}
	}

//vytvorenie pola	
	//tato sa vola interne 
	private void SetSize()
	{
		Data=make2Dcell(sizX,sizY);
	}

	//pre verejnost po vytvoreni sa vyvola aj prekreslenie
	/**
	 * funkcia pre nastavenie velkosti automatu (v bunkach, nie pixeloch)
	 * @param int x pocet buniek horizontalne
	 * @param int y pocet buniek vertikalne
	 */
	public void SetSize(int x,int y)
	{
		sizX = x;
		sizY = y;
		SetSize();
		kresli();
	}
	
	/**
	 * 	funkcia reinicializuje automat
	 */
	public void reset()
    {
		SetDemo(demo);
	}
	/**
     * 	funkcia vymaze plochu automatu
	 */
	public void clear()
	{   
		for(int i=0;i<sizX;i++)
			for(int j=0;j<sizY;j++)
					Data[i][j].w=Data[i][j].n=Data[i][j].e=Data[i][j].s=0;
		kresli();
	}

// ----------------------------------------------------------------
// aplikacia pravidla - prekodovanie
	private void SwapCells(int Cells[])
	{
		int iCnt, iNewCnt;
		
		iCnt = Cells[3];
		iCnt <<= 1;
		iCnt |= Cells[2];
		iCnt <<= 1;
		iCnt |= Cells[1];
		iCnt <<= 1;
		iCnt |= Cells[0];
						 
		iNewCnt = swapArray[iCnt];

		if(iNewCnt!=iCnt) zmena=true; //autostop ak je povoleny
		
		Cells[0] = iNewCnt & 1;
		iNewCnt >>= 1;
		Cells[1] = iNewCnt & 1;
		iNewCnt >>= 1;
		Cells[2] = iNewCnt & 1;
		iNewCnt >>= 1;
		Cells[3] = iNewCnt & 1;
	}

// ----------------------------------------------------------------
// Jedna faza cyklu
	/**
	 * 	nosna funkcia - jeden krok automatu
	 */
	public void step()
	{  
		int bunky[] = new int[4];  // Susedne 4 pre aplikaciu pravidla 
		State16Cell tempData[][] = make2Dcell(sizX,sizY); //nutne pre paralelny chod
		zmena=false;
		
		for(int i=0;i<sizX;i++)
			for(int j=0;j<sizY;j++)
			{int wx = (isWrap&&i==0)?sizX-1:i-1;
			 int wy = j;
			 int ex = (isWrap&&i==sizX-1)?0:i+1;
			 int ey = j;
			 int nx = i;
			 int ny = (isWrap&&j==0)?sizY-1:j-1;
			 int sx = i;
			 int sy = (isWrap&&j==sizY-1)?0:j+1;
			 			 
			 bunky[0]=(wx<0)? 0:Data[wx][wy].e;
			 bunky[1]=(ny<0)? 0:Data[nx][ny].s;
			 bunky[2]=(ex>=sizX)? 0:Data[ex][ey].w;
			 bunky[3]=(sy>=sizY)? 0:Data[sx][sy].n;
			 
			 SwapCells(bunky);
			 
			 tempData[i][j].w = bunky[0];
			 tempData[i][j].n = bunky[1];
			 tempData[i][j].e = bunky[2];
			 tempData[i][j].s = bunky[3];
			}
		krok++;
		user_intf.krokuj(krok);
		Data=tempData;
		kresli();
		if(autorestart&&!zmena) {
			krok=0;
			reset();	//skoncili sme a reinicializujem
		}
		if(!autorestart&&!zmena) user_intf.bba_stop();	//zastavime chod
	}
	
	/**
	 * 	implementacia funkcie doplnovanie elementov pouzivatelom - spracuje klik na bunku
	 * @param int x - suradnica x
	 * @param int y - suradnica y
	 */
	protected void SetElement(int x,int y)
	{   
		if(demo==1){
			
		if(timer==null)
		{
			Dimension d = getSize();
			int GRIDSIZE=Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky
			GRIDSIZE = ((GRIDSIZE % 2) == 1) ? GRIDSIZE-1 : GRIDSIZE;
			int startx=(d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
			int starty=(d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
	
			int posx=(x-startx)/GRIDSIZE;	//urci zodpovedajucu suradnicu bunky
			int posy=(y-starty)/GRIDSIZE;
			int sx=(x-startx)%GRIDSIZE;		//suradnice pre urcenie polygonu/mnohouholnik/tu trojuholnika
			int sy=(y-starty)%GRIDSIZE;
			
			//definujeme regiony, teda vrcholy mnohouholnika/tu 3 vrcholy trojuholnika 4x
			Polygon west=new Polygon();
			west.addPoint(0,0);
			west.addPoint(0,GRIDSIZE);
			west.addPoint(GRIDSIZE/2,GRIDSIZE/2);
			
			Polygon east=new Polygon();
			east.addPoint(GRIDSIZE,0);
			east.addPoint(GRIDSIZE,GRIDSIZE);
			east.addPoint(GRIDSIZE/2,GRIDSIZE/2);
			
			Polygon north=new Polygon();
			north.addPoint(0,0);
			north.addPoint(GRIDSIZE,0);
			north.addPoint(GRIDSIZE/2,GRIDSIZE/2);
			
			Polygon south=new Polygon();
			south.addPoint(0,GRIDSIZE);
			south.addPoint(GRIDSIZE,GRIDSIZE);
			south.addPoint(GRIDSIZE/2,GRIDSIZE/2);
			
			
			if(west.contains(sx,sy)) //sme v regione
				Data[posx][posy].w=(Data[posx][posy].w==1)? 0 : 1; //zmeni stav bunky
			if(north.contains(sx,sy))
				Data[posx][posy].n=(Data[posx][posy].n==1)? 0 : 1; //zmeni stav bunky
			if(east.contains(sx,sy))
				Data[posx][posy].e=(Data[posx][posy].e==1)? 0 : 1; //zmeni stav bunky
			if(south.contains(sx,sy))
				Data[posx][posy].s=(Data[posx][posy].s==1)? 0 : 1; //zmeni stav bunky
			kresli();
		}
		}
	}

//tu sa kresli
	private void kresli()
	{
		Dimension d=getSize(); //velkost plochy
		imbuffer=createImage(d.width,d.height); //vytvorenie buffra - vlastne sa vola vzdy pred kreslenim, vytvori image space pre dvojity buffering 
		if(imbuffer!=null){ //mozeme kreslit
			kresli(imbuffer.getGraphics()); //naplnime buffer
			if(demo==4)
				kresliPosunO2(imbuffer.getGraphics());
			if(demo==5)
				kresliPosunO3(imbuffer.getGraphics());
			if(demo==9)
				kresliOneskorenie(imbuffer.getGraphics());
			if(demo==6)
				kresliIBrana(imbuffer.getGraphics());
			if(demo==7)
				kresliSBrana(imbuffer.getGraphics());
			if(demo==8)
				kresliNetrivialneKrizenie(imbuffer.getGraphics());
		}
		repaint(); //vyvolame paint()
	}
	
//	!!!!  kresli() != kresli(Graphics g)  !!!!!  ale prva vola druhu, teda su ako jedna
	
	private void kresli(Graphics g)   // je volana o tri riadky vyssie, g su informacie o grafic. vystupe ako pixle,, sirka ciari, ..
	{ 
		Dimension d = getSize();
		int GRIDSIZE = Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky
		GRIDSIZE = ((GRIDSIZE % 2) == 1) ? GRIDSIZE-1 : GRIDSIZE; //potrebujeme aby bolo parne a mohli sme urcit polovicu
	    int startx = (d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
		int starty = (d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
		int endx = startx+GRIDSIZE*sizX;
		int endy = starty+GRIDSIZE*sizY;
				
		//vnutorna mriezka - kriz /siva/
		g.setColor(Color.lightGray);
		for (int i=0;i<sizX;i++)
			for (int j=0;j<sizY;j++)
			{
				int si=startx+i*GRIDSIZE;
				int sj=starty+j*GRIDSIZE;
				g.drawLine(si,sj,si+GRIDSIZE,sj+GRIDSIZE);
				g.drawLine(si+GRIDSIZE,sj,si,sj+GRIDSIZE);
			}
		
		g.setColor(Color.black);
		
		//mriezka - plna ciara /cierna/
		for (int x = startx; x <= endx; x += GRIDSIZE) 
		{
			g.drawLine(x, starty, x, endy - 1);
		}
		for (int y = starty; y <= endy; y += GRIDSIZE)
		{
			g.drawLine(startx, y, endx - 1, y);
		}
		
		//vlastne data
		g.setColor (farba);
		for(int i=0;i<sizX;i++)
			for(int j=0;j<sizY;j++)
			{	int x[]=new int[3];
				int y[]=new int[3];
				int targetx=GRIDSIZE*i+startx;
				int targety=GRIDSIZE*j+starty;
				
				x[2]=targetx+GRIDSIZE/2;
				y[2]=targety+GRIDSIZE/2;
				
				if(Data[i][j].w==1)
				{
					x[1]=x[0]=targetx;
					y[0]=targety;
					y[1]=targety+GRIDSIZE;
					g.fillPolygon(x,y,3);
				}
				if(Data[i][j].e==1)
				{
					x[1]=x[0]=targetx+GRIDSIZE;
					y[0]=targety;
					y[1]=targety+GRIDSIZE;
					g.fillPolygon(x,y,3);
				}
				if(Data[i][j].n==1)
				{
					x[0]=targetx;
					x[1]=targetx+GRIDSIZE;
					y[1]=y[0]=targety;
					g.fillPolygon(x,y,3);					
				}
				if(Data[i][j].s==1)
				{
					x[0]=targetx;
					x[1]=targetx+GRIDSIZE;
					y[1]=y[0]=targety+GRIDSIZE;
					g.fillPolygon(x,y,3);					
				}
			}
	}
  
	private void kresliPosunO2(Graphics g)   // je volana o tri riadky vyssie, g su informacie o grafic. vystupe ako pixle,, sirka ciari, ..
	{ 
		Dimension d = getSize();
		int GRIDSIZE = Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky
		GRIDSIZE = ((GRIDSIZE % 2) == 1) ? GRIDSIZE-1 : GRIDSIZE; //potrebujeme aby bolo parne a mohli sme urcit polovicu
		int b=GRIDSIZE/2;
	    int startx = (d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
		int starty = (d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
		int endx = startx+GRIDSIZE*sizX;
		int endy = starty+GRIDSIZE*sizY;
		
		g.setColor(Color.BLUE);
		{
			g.drawLine(startx,starty+8*GRIDSIZE+b,startx+6*GRIDSIZE+b,starty+8*GRIDSIZE+b);
			g.drawLine(startx+6*GRIDSIZE+b,starty+8*GRIDSIZE+b,startx+6*GRIDSIZE+b,starty+10*GRIDSIZE+b);
			g.drawLine(startx+6*GRIDSIZE+b,starty+10*GRIDSIZE+b,endx,starty+10*GRIDSIZE+b);
		}
		
		g.setColor(Color.RED);
		{
			g.drawLine(startx,starty+8*GRIDSIZE+b+2,endx,starty+8*GRIDSIZE+b+2);
		}
		
	}
	
	private void kresliPosunO3(Graphics g)   // je volana o tri riadky vyssie, g su informacie o grafic. vystupe ako pixle,, sirka ciari, ..
	{ 
		Dimension d = getSize();
		int GRIDSIZE = Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky
		GRIDSIZE = ((GRIDSIZE % 2) == 1) ? GRIDSIZE-1 : GRIDSIZE; //potrebujeme aby bolo parne a mohli sme urcit polovicu
		int b=GRIDSIZE/2;
	    int startx = (d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
		int starty = (d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
		int endx = startx+GRIDSIZE*sizX;
		int endy = starty+GRIDSIZE*sizY;
		
		g.setColor(Color.BLUE);
		{
			g.drawLine(startx,starty+8*GRIDSIZE+b,startx+6*GRIDSIZE+b,starty+8*GRIDSIZE+b);
			g.drawLine(startx+6*GRIDSIZE+b,starty+8*GRIDSIZE+b,startx+6*GRIDSIZE+b,starty+11*GRIDSIZE+b);
			g.drawLine(startx+6*GRIDSIZE+b,starty+11*GRIDSIZE+b,endx,starty+11*GRIDSIZE+b);
		}
		
		g.setColor(Color.RED);
		{
			g.drawLine(startx,starty+8*GRIDSIZE+b+2,endx,starty+8*GRIDSIZE+b+2);
		}
		
	}
	
	private void kresliOneskorenie(Graphics g)   // je volana o tri riadky vyssie, g su informacie o grafic. vystupe ako pixle,, sirka ciari, ..
	{ 
		Dimension d = getSize();
		int GRIDSIZE = Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky
		GRIDSIZE = ((GRIDSIZE % 2) == 1) ? GRIDSIZE-1 : GRIDSIZE; //potrebujeme aby bolo parne a mohli sme urcit polovicu
		int b=GRIDSIZE/2;
	    int startx = (d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
		int starty = (d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
		int endx = startx+GRIDSIZE*sizX;
		int endy = starty+GRIDSIZE*sizY;
		
				
		g.setColor(Color.RED);
		{
			g.drawLine(startx,starty+8*GRIDSIZE+b-2,endx,starty+8*GRIDSIZE+b-2);
		}
	
		g.setColor(Color.BLUE);
		{
			g.drawLine(startx,starty+8*GRIDSIZE+b,startx+6*GRIDSIZE+b,starty+8*GRIDSIZE+b);
			g.drawLine(startx+6*GRIDSIZE+b,starty+8*GRIDSIZE+b,startx+6*GRIDSIZE+b,starty+10*GRIDSIZE+b);
			g.drawLine(startx+6*GRIDSIZE+b,starty+10*GRIDSIZE+b,startx+9*GRIDSIZE+b,starty+10*GRIDSIZE+b);
			g.drawLine(startx+9*GRIDSIZE+b,starty+10*GRIDSIZE+b,startx+9*GRIDSIZE+b,starty+8*GRIDSIZE+b);
			g.drawLine(startx+9*GRIDSIZE+b,starty+8*GRIDSIZE+b,endx,starty+8*GRIDSIZE+b);
		}
	}
	
	private void kresliIBrana(Graphics g)   // je volana o tri riadky vyssie, g su informacie o grafic. vystupe ako pixle,, sirka ciari, ..
	{ 
		Dimension d = getSize();
		int GRIDSIZE = Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky
		GRIDSIZE = ((GRIDSIZE % 2) == 1) ? GRIDSIZE-1 : GRIDSIZE; //potrebujeme aby bolo parne a mohli sme urcit polovicu
		int b=GRIDSIZE/2;
	    int startx = (d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
		int starty = (d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
		int endx = startx+GRIDSIZE*sizX;
		int endy = starty+GRIDSIZE*sizY;
		
				
		g.setColor(Color.RED);
		{
			g.drawLine(startx,starty+7*GRIDSIZE+b+2,endx,starty+7*GRIDSIZE+b+2);
		}
		
		g.setColor(Color.GREEN);
		{
			g.drawLine(startx+8*GRIDSIZE+b-2,endy,startx+8*GRIDSIZE+b-2,starty);
		}
		
		g.setColor(Color.BLUE);
		{
			g.drawLine(startx,starty+7*GRIDSIZE+b,startx+7*GRIDSIZE+b,starty+7*GRIDSIZE+b);
			g.drawLine(startx+8*GRIDSIZE+b,endy,startx+8*GRIDSIZE+b,starty+8*GRIDSIZE+b);
			g.drawLine(startx+7*GRIDSIZE+b,starty+7*GRIDSIZE+b,startx+7*GRIDSIZE+b,starty);
			g.drawLine(startx+8*GRIDSIZE+b,starty+8*GRIDSIZE+b,endx,starty+8*GRIDSIZE+b);
		}
	}
	
	private void kresliNetrivialneKrizenie(Graphics g)   // je volana o tri riadky vyssie, g su informacie o grafic. vystupe ako pixle,, sirka ciari, ..
	{ 
		Dimension d = getSize();
		int GRIDSIZE = Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky
		GRIDSIZE = ((GRIDSIZE % 2) == 1) ? GRIDSIZE-1 : GRIDSIZE; //potrebujeme aby bolo parne a mohli sme urcit polovicu
		int b=GRIDSIZE/2;
	    int startx = (d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
		int starty = (d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
		int endx = startx+GRIDSIZE*sizX;
		int endy = starty+GRIDSIZE*sizY;
		
				
		g.setColor(Color.RED);
		{
			g.drawLine(startx,starty+8*GRIDSIZE+b+2,endx,starty+8*GRIDSIZE+b+2);
		}
		
		g.setColor(Color.GREEN);
		{
			g.drawLine(startx+7*GRIDSIZE+b-2,endy,startx+7*GRIDSIZE+b-2,starty);
		}
		
		g.setColor(Color.BLUE);
		{
			g.drawLine(startx+7*GRIDSIZE+b,endy,startx+7*GRIDSIZE+b,starty+9*GRIDSIZE+b);
			g.drawLine(startx+7*GRIDSIZE+b,starty+9*GRIDSIZE+b,startx+8*GRIDSIZE+b,starty+9*GRIDSIZE+b);
			g.drawLine(startx+8*GRIDSIZE+b,starty+9*GRIDSIZE+b,startx+8*GRIDSIZE+b,starty+8*GRIDSIZE+b);
			g.drawLine(startx+8*GRIDSIZE+b,starty+8*GRIDSIZE+b,endx,starty+8*GRIDSIZE+b);
			
			g.drawLine(startx,starty+8*GRIDSIZE+b,startx+6*GRIDSIZE+b,starty+8*GRIDSIZE+b);
			g.drawLine(startx+6*GRIDSIZE+b,starty+8*GRIDSIZE+b,startx+6*GRIDSIZE+b,starty+7*GRIDSIZE+b);
			g.drawLine(startx+6*GRIDSIZE+b,starty+7*GRIDSIZE+b,startx+7*GRIDSIZE+b,starty+7*GRIDSIZE+b);
			g.drawLine(startx+7*GRIDSIZE+b,starty+7*GRIDSIZE+b,startx+7*GRIDSIZE+b,starty);
		}
	}
	
	private void kresliSBrana(Graphics g)   // je volana o tri riadky vyssie, g su informacie o grafic. vystupe ako pixle,, sirka ciari, ..
	{ 
		Dimension d = getSize();
		int GRIDSIZE = Math.min(d.height/sizY,d.width/sizX); //urci velkost mriezky
		GRIDSIZE = ((GRIDSIZE % 2) == 1) ? GRIDSIZE-1 : GRIDSIZE; //potrebujeme aby bolo parne a mohli sme urcit polovicu
		int b=GRIDSIZE/2;
	    int startx = (d.width-GRIDSIZE*sizX)/2; //urci posun  x od [0,0] presuvame [0,0]
		int starty = (d.height-GRIDSIZE*sizY)/2; //urci posun y od [0,0] na [startx,starty] 
		int endx = startx+GRIDSIZE*sizX;
		int endy = starty+GRIDSIZE*sizY;
		
				
		g.setColor(Color.RED);
		{
			g.drawLine(startx,starty+10*GRIDSIZE+b+2,startx+13*GRIDSIZE+b,starty+10*GRIDSIZE+b+2);
			g.drawLine(startx+13*GRIDSIZE+b,starty+10*GRIDSIZE+b+2,startx+13*GRIDSIZE+b,starty+11*GRIDSIZE+b+2);
			g.drawLine(startx+13*GRIDSIZE+b,starty+11*GRIDSIZE+b+2,startx+12*GRIDSIZE+b+2,starty+11*GRIDSIZE+b+2);
			g.drawLine(startx+12*GRIDSIZE+b+2,starty+11*GRIDSIZE+b+2,startx+12*GRIDSIZE+b+2,starty);
		}
		
		g.setColor(Color.GREEN);
		{
			g.drawLine(startx+6*GRIDSIZE+b-2,endy,startx+6*GRIDSIZE+b-2,starty);
		}
		
		g.setColor(Color.BLUE);
		{
			g.drawLine(startx+6*GRIDSIZE+b,endy,startx+6*GRIDSIZE+b,starty+11*GRIDSIZE+b);
			g.drawLine(startx+6*GRIDSIZE+b,starty+11*GRIDSIZE+b,startx+9*GRIDSIZE+b,starty+11*GRIDSIZE+b);
			g.drawLine(startx+9*GRIDSIZE+b,starty+11*GRIDSIZE+b,startx+9*GRIDSIZE+b,starty+7*GRIDSIZE+b);
			g.drawLine(startx+9*GRIDSIZE+b,starty+7*GRIDSIZE+b,startx+13*GRIDSIZE+b,starty+7*GRIDSIZE+b);
			g.drawLine(startx+13*GRIDSIZE+b,starty+7*GRIDSIZE+b,startx+13*GRIDSIZE+b,starty+3*GRIDSIZE+b);
			g.drawLine(startx+13*GRIDSIZE+b,starty+3*GRIDSIZE+b,endx,starty+3*GRIDSIZE+b);
			
			g.drawLine(startx,starty+10*GRIDSIZE+b,startx+5*GRIDSIZE+b,starty+10*GRIDSIZE+b);
			g.drawLine(startx+5*GRIDSIZE+b,starty+10*GRIDSIZE+b,startx+5*GRIDSIZE+b,starty+3*GRIDSIZE+b);
			g.drawLine(startx+5*GRIDSIZE+b,starty+3*GRIDSIZE+b,startx+9*GRIDSIZE+b,starty+3*GRIDSIZE+b);
			g.drawLine(startx+9*GRIDSIZE+b,starty+3*GRIDSIZE+b,startx+9*GRIDSIZE+b,starty+2*GRIDSIZE+b);
			g.drawLine(startx+9*GRIDSIZE+b,starty+2*GRIDSIZE+b,startx+12*GRIDSIZE+b,starty+2*GRIDSIZE+b);
			g.drawLine(startx+12*GRIDSIZE+b,starty+2*GRIDSIZE+b,startx+12*GRIDSIZE+b,starty);
			
		}
	}
	
	/**
	 * implementacia (prekrytie) metody
	 * Metoda realizuje update
	 */
	public void update(Graphics g)
	{
		paint(g);
	}
	/**
	 * implementacia (prekrytie) metody
	 * Metoda realizuje vlastne vykreslovanie
	 */	
	public void paint(Graphics g) 
	{ 
		Dimension d = getSize();
		//cistime obrazovku
		g.clearRect (0,0,d.width,d.height);
		//vlastne kreslenie
		if(imbuffer!=null)
			g.drawImage(imbuffer,0,0,this); //zobrazime pripraveny buffer
		else {
			kresli(g); //nemame buffer musime kreslit normalne
			
		}
	}
	
	/**								
	 * funkcia vlozi stabilny blok na suradnice x,y
	 *  ___
	 * |  /| x,y su suradnice bunky zaplnenej v South a East regione
	 * | /.| 
	 * |/..|
	 */
	private void placeBox(int x, int y)
	{
		Data[x][y].s=Data[x+1][y].s=1;          //w,n,e,s su dat.atributy objektu Data triedy State16Cell 
		Data[x][y+1].n=Data[x+1][y+1].n=1;
		Data[x][y].e=Data[x][y+1].e=1;
		Data[x+1][y].w=Data[x+1][y+1].w=1;
	}
	
	/**
	 * funkcia vlozi gulu na poziciu x,y (pozicia je brana od konca gule)
	 */
	private void placeBall(int x, int y, char orientation, int signal)
	{
		switch(orientation)
		{   
		case 'e':// >
				Data[x][y].e=Data[x+2][y].e=signal;   //dat.premenna e instancie Data treidy State16Cell
				break;                      //definuje dve gule naraz!!
		case 'w':// <
				Data[x][y].w=Data[x-2][y].w=signal;
				break;
		case 'n':// ^
				Data[x][y].n=Data[x][y-2].n=signal;
				break;
		case 's':// v
				Data[x][y].s=Data[x][y+2].s=signal;
				break;
		default:break;
		}
	}
}